#ifndef __FNCPRS_H__
#define __FNCPRS_H__

#include <string>
#include <exception>
#include <map>

using namespace std;

template <class T>
class function_parser
{
public:

	typedef T (*TDPUNT)(T n1, T n2);
	typedef T (*TOPUNT)(T n);

	function_parser();
	function_parser(const char *func, const char *inc);
	~function_parser();

	char * get_func() const;
	char * get_inc() const;
	bool add_one_operator(char *name, TOPUNT func);
	bool add_double_operator(char *name, TDPUNT func);

	void load_default_operators();
	void load_default_math_operations();

private:
	std::string *_original_func;
	std::map<char, TDPUNT> *_double_operator;
	std::map<char, TOPUNT> *_one_operator;
	std::map<char *, char> *_half_map;
	char *_incognita;
	char _assign;

	void trim(std::string &str);
	bool find_errors();

	T my_sin(T n);
	T my_cos(T n);
	T my_tan(T n);
	T my_cotan(T n);
	T my_plus(T n1, T n2);
	T my_minus(T n1, T n2);
	T my_mult(T n1, T n2);
	T my_div(T n1, T n2) throw(int);
};

#endif
